PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Static Public Member Functions | List of all members
PMIMEInfo Class Reference

This class contains the Multipurpose Internet Mail Extensions parameters and variables. More...

`#include <mime.h>`

Inheritance diagram for PMIMEInfo:
[legend]
Collaboration diagram for PMIMEInfo:
[legend]

## Public Member Functions
| PMIMEInfo ()
| PMIMEInfo (istream &strm)
| Construct a MIME information dictionary from the specified source. More...
| PMIMEInfo (PInternetProtocol &socket)
| PMIMEInfo (const PStringToString &dict)
| PMIMEInfo (const PString &str)
virtual void | PrintOn (ostream &strm) const
| Output the contents of the MIME dictionary to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the MIME dictionary from the stream. More...
PBoolean | Read (PInternetProtocol &socket)
| Read MIME information from the socket. More...
PBoolean | Write (PInternetProtocol &socket) const
| Write MIME information to the socket. More...
PString | AsString () const
| Return a string presentation of the MIME. More...
bool | AddMIME (const PString &line)
| Add a MIME field given a "name: value" format string. More...
bool | AddMIME (const PString &fieldName, const PString &fieldValue)
bool | AddMIME (const PMIMEInfo &mime)
virtual bool | InternalAddMIME (const PString &fieldName, const PString &fieldValue)
bool | GetComplex (const char *key, PStringToString &info) const
| Get a complex MIME field. More...
bool | GetComplex (const PString &key, PStringToString &info) const
bool | GetComplex (const PCaselessString &key, PStringToString &info) const
bool | GetComplex (const PCaselessString &(*key)(), PStringToString &info) const
bool | DecodeMultiPartList (PMultiPartList &parts, const PString &body, const PCaselessString &key) const
| Decode parts from a multipart body using the field value. More...
bool | DecodeMultiPartList (PMultiPartList &parts, const PString &body, const PCaselessString &(*key)()=ContentTypeTag) const
| Decode parts from a multipart body using the field value. More...
virtual ostream & | PrintContents (ostream &strm) const
| Output the contents without the trailing CRLF. More...
Public Member Functions inherited from PStringOptions
| PStringOptions ()
| PStringOptions (const PString &str)
| PStringOptions (const PStringToString &other)
PStringOptions & | operator= (const PStringToString &other)
bool | Contains (const char *key) const
| Determine if the specified key is present. More...
bool | Contains (const PString &key) const
bool | Contains (const PCaselessString &key) const
bool | Contains (const PCaselessString &(*key)()) const
PString * | GetAt (const char *key) const
PString * | GetAt (const PString &key) const
PString * | GetAt (const PCaselessString &key) const
PString * | GetAt (const PCaselessString &(*key)()) const
PBoolean | SetAt (const char *key, const PString &data)
PBoolean | SetAt (const PString &key, const PString &data)
PBoolean | SetAt (const PCaselessString &key, const PString &data)
PBoolean | SetAt (const PCaselessString &(*key)(), const PString &data)
PString * | RemoveAt (const char *key)
PString * | RemoveAt (const PString &key)
PString * | RemoveAt (const PCaselessString &key)
PString * | RemoveAt (const PCaselessString &(*key)())
PString | GetString (const char *key, const char *dflt=NULL) const
| Get an option value. More...
PString | GetString (const PString &key, const char *dflt=NULL) const
PString | GetString (const PCaselessString &key, const char *dflt=NULL) const
PString | GetString (const PCaselessString &(*key)(), const char *dflt=NULL) const
bool | SetString (const char *key, const PString &value)
| Set the option value. More...
bool | SetString (const PString &key, const PString &value)
bool | SetString (const PCaselessString &key, const PString &value)
bool | SetString (const PCaselessString &(*key)(), const PString &value)
bool | GetBoolean (const char *key, bool dflt=false) const
| Get the option value as a boolean. More...
bool | GetBoolean (const PString &key, bool dflt=false) const
bool | GetBoolean (const PCaselessString &key, bool dflt=false) const
bool | GetBoolean (const PCaselessString &(*key)(), bool dflt=false) const
void | SetBoolean (const char *key, bool value)
| Set the option value as a boolean. More...
void | SetBoolean (const PString &key, bool value)
void | SetBoolean (const PCaselessString &key, bool value)
void | SetBoolean (const PCaselessString &(*key)(), bool value)
long | GetInteger (const char *key, long dflt=0) const
| Get the option value as an integer. More...
long | GetInteger (const PString &key, long dflt=0) const
long | GetInteger (const PCaselessString &key, long dflt=0) const
long | GetInteger (const PCaselessString &(*key)(), long dflt=0) const
void | SetInteger (const char *key, long value)
| Set an integer value for the particular MIME info field. More...
void | SetInteger (const PString &key, long value)
void | SetInteger (const PCaselessString &key, long value)
void | SetInteger (const PCaselessString &(*key)(), long value)
template<typename E >
E | GetEnum (const char *key, E dflt) const
| Get the option value as an enum. More...
template<typename E >
E | GetEnum (const PString &key, E dflt) const
template<typename E >
E | GetEnum (const PCaselessString &key, E dflt) const
template<typename E >
E | GetEnum (const PCaselessString &(*key)(), E dflt) const
template<typename E >
void | SetEnum (const char *key, E value)
| Set an enum value for the particular MIME info field. More...
template<typename E >
void | SetEnum (const PString &key, E value)
template<typename E >
void | SetEnum (const PCaselessString &key, E value)
template<typename E >
void | SetEnum (const PCaselessString &(*key)(), E value)
double | GetReal (const char *key, double dflt=0) const
| Get the option value as a floating point real. More...
double | GetReal (const PString &key, double dflt=0) const
double | GetReal (const PCaselessString &key, double dflt=0) const
double | GetReal (const PCaselessString &(*key)(), double dflt=0) const
void | SetReal (const char *key, double value, int decimals)
| Set a floating point real value for the particular MIME info field. More...
void | SetReal (const PString &key, double value, int decimals)
void | SetReal (const PCaselessString &key, double value, int decimals)
void | SetReal (const PCaselessString &(*key)(), double value, int decimals)
__inline bool | Has (const char *key) const
| Determine of the option exists. More...
__inline bool | Has (const PString &key) const
__inline bool | Has (const PCaselessString &key) const
__inline bool | Has (const PCaselessString &(*key)()) const
__inline PString | Get (const char *key, const char *dflt=NULL) const
| Get the option value. More...
__inline PString | Get (const PString &key, const char *dflt=NULL) const
__inline PString | Get (const PCaselessString &key, const char *dflt=NULL) const
__inline PString | Get (const PCaselessString &(*key)(), const char *dflt=NULL) const
__inline PString | Get (const char *key, const PString &dflt) const
__inline PString | Get (const PString &key, const PString &dflt) const
__inline PString | Get (const PCaselessString &key, const PString &dflt) const
__inline PString | Get (const PCaselessString &(*key)(), const PString &dflt) const
__inline bool | Set (const char *key, const PString &value)
| Set the option value. More...
__inline bool | Set (const PString &key, const PString &value)
__inline bool | Set (const PCaselessString &key, const PString &value)
__inline bool | Set (const PCaselessString &(*key)(), const PString &value)
__inline void | Remove (const char *key)
| Remove option value. More...
__inline void | Remove (const PString &key)
__inline void | Remove (const PCaselessString &key)
__inline void | Remove (const PCaselessString &(*key)())
Public Member Functions inherited from PStringToString
char ** | ToCharArray (bool withEqualSign, PCharArray *storage=NULL) const
| Create an array of C strings. More...
void | FromString (const PString &str)
| Set dictionary from string. More...
| PStringToString (PINDEX count, const Initialiser *init, PBoolean caselessKeys=false, PBoolean caselessValues=false)
| Initialise the string dictionary of strings from the static array. More...
| PStringToString (const PString &str)
| Initialise the string dictionary from the string. More...
Public Member Functions inherited from PStringDictionary< K >
| PStringDictionary ()
| Create a new, empty, dictionary. More...
virtual PObject * | Clone () const
| Make a complete duplicate of the dictionary. More...
PString | operator() (const K &key, const char *dflt=NULL) const
| Get the string contained in the dictionary at the `key` position. More...
virtual PBoolean | SetAt (const K &key, const PString &str)
| Add a new object to the collection. More...
Public Member Functions inherited from PDictionary< K, PString >
| PDictionary ()
| Create a new, empty, dictionary. More...
const PString & | operator[] (const K &key) const
| Get the object contained in the dictionary at the `key` position. More...
PString & | operator[] (const K &key)
PBoolean | Contains (const K &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual PString * | RemoveAt (const K &key)
| Remove an object at the specified `key`. More...
virtual PBoolean | SetAt (const K &key, PString *obj)
| Add a new object to the collection. More...
virtual PString * | GetAt (const K &key) const
| Get the object at the specified key position. More...
const K & | GetKeyAt (PINDEX index) const
| Get the key in the dictionary at the ordinal index position. More...
PString & | GetDataAt (PINDEX index) const
| Get the data in the dictionary at the ordinal index position. More...
PArray< K > | GetKeys () const
| Get an array containing all the keys for the dictionary. More...
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
iterator | find (const K &key)
const_iterator | find (const K &k) const
void | erase (const iterator &it)
void | erase (const const_iterator &it)
Public Member Functions inherited from PAbstractDictionary
PINLINE | PAbstractDictionary ()
| Create a new, empty, dictionary. More...
virtual PINDEX | Insert (const PObject &key, PObject *obj)
| Insert a new object into the dictionary. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified index. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove an object at the specified index. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified index to the new value. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified index position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
virtual P_DEPRECATED PBoolean | SetDataAt (PINDEX index, PObject *obj)
| Set the data at the specified ordinal index position in the dictionary. More...
virtual PObject * | AbstractSetAt (const PObject &key, PObject *obj)
| Add a new object to the collection. More...
virtual PObject & | GetRefAt (const PObject &key) const
| Get the object at the specified key position. More...
virtual PObject * | AbstractGetAt (const PObject &key) const
| Get the object at the specified key position. More...
virtual void | AbstractGetKeys (PArrayObjects &keys) const
| Get an array containing all the keys for the dictionary. More...
Public Member Functions inherited from PHashTable
| PHashTable ()
| Create a new, empty, hash table. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two hash tables. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for hash table. More...
PINLINE PBoolean | AbstractContains (const PObject &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual const PObject & | AbstractGetKeyAt (PINDEX index) const
| Get the key in the hash table at the ordinal index position. More...
virtual PObject & | AbstractGetDataAt (PINDEX index) const
| Get the data in the hash table at the ordinal index position. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions
static bool | ParseComplex (const PString &str, PStringToString &info)
| Parse the string as a complex field, see GetComplex() More...
static const PCaselessString & | ContentTypeTag ()
static const PCaselessString & | ContentDispositionTag ()
static const PCaselessString & | ContentTransferEncodingTag ()
static const PCaselessString & | ContentDescriptionTag ()
static const PCaselessString & | ContentIdTag ()
static const PCaselessString & | TextPlain ()
static void | SetAssociation (const PStringToString &allTypes, PBoolean merge=true)
| Set an association between a file type and a MIME content type. More...
static void | SetAssociation (const PString &fileType, const PString &contentType)
static PString | GetContentType (const PString &fileType)
| Look up the file type to MIME content type association dictionary and return the MIME content type string. More...

## Additional Inherited Members
Public Types inherited from PDictionary< K, PString >
typedef K | key_type
typedef PString | data_type
typedef PDictionary< K, PString > | dict_type
Public Attributes inherited from PHashTable
PHashTableInfo * | hashTable
Protected Member Functions inherited from PStringDictionary< K >
| PStringDictionary (int dummy, const PStringDictionary *c)
Protected Attributes inherited from PContainer
PContainerReference * | reference
Friends inherited from PObject

## Detailed Description

This class contains the Multipurpose Internet Mail Extensions parameters and variables.

## Constructor & Destructor Documentation

PMIMEInfo::PMIMEInfo | ( |  | ) |
| inline

PMIMEInfo::PMIMEInfo | ( | istream & | strm | ) |

Construct a MIME information dictionary from the specified source.

Parameters

  strm | Stream to read the objects contents from.

PMIMEInfo::PMIMEInfo | ( | PInternetProtocol & | socket | ) |

Parameters

  socket | Application socket to read MIME info.

PMIMEInfo::PMIMEInfo | ( | const PStringToString & | dict | ) |

PMIMEInfo::PMIMEInfo | ( | const PString & | str | ) |

## Member Function Documentation

bool PMIMEInfo::AddMIME | ( | const PString & | line | ) |

Add a MIME field given a "name: value" format string.

Note that if the field name was already in the MIME dictionary then this will append the new value after a '\n' character to the previous value.

Returns
  true is a field was added.

bool PMIMEInfo::AddMIME | ( | const PString & | fieldName,
|  | const PString & | fieldValue
| ) |  |
| inline

Parameters

  fieldName | MIME field name
  fieldValue | MIME field value

References InternalAddMIME().

bool PMIMEInfo::AddMIME | ( | const PMIMEInfo & | mime | ) |

PString PMIMEInfo::AsString | ( |  | ) | const

Return a string presentation of the MIME.

static const PCaselessString& PMIMEInfo::ContentDescriptionTag | ( |  | ) |
| static

static const PCaselessString& PMIMEInfo::ContentDispositionTag | ( |  | ) |
| static

Referenced by PRFC822Channel::ContentDispositionTag().

static const PCaselessString& PMIMEInfo::ContentIdTag | ( |  | ) |
| static

static const PCaselessString& PMIMEInfo::ContentTransferEncodingTag | ( |  | ) |
| static

Referenced by PRFC822Channel::ContentTransferEncodingTag().

static const PCaselessString& PMIMEInfo::ContentTypeTag | ( |  | ) |
| static

Referenced by PHTTP::ContentTypeTag(), and PRFC822Channel::ContentTypeTag().

bool PMIMEInfo::DecodeMultiPartList | ( | PMultiPartList & | parts,
|  | const PString & | body,
|  | const PCaselessString & | key
| ) |  | const

Decode parts from a multipart body using the field value.

Parameters

  parts | Extracted parts.
  body | Body to decode
  key | MIME key for multipart info

Referenced by PHTTPConnectionInfo::DecodeMultipartFormInfo().

bool PMIMEInfo::DecodeMultiPartList | ( | PMultiPartList & | parts,
|  | const PString & | body,
|  | const PCaselessString &(*)() | key = `ContentTypeTag`
| ) |  | const
| inline

Decode parts from a multipart body using the field value.

Parameters

  parts | Extracted parts.
  body | Body to decode
  key | MIME key for multipart info

References DecodeMultiPartList().

Referenced by DecodeMultiPartList().

bool PMIMEInfo::GetComplex | ( | const char * | key,
|  | PStringToString & | info
| ) |  | const
| inline

Get a complex MIME field.

This will parse a complex MIME field of the general form:

key: base-value;tag1=token;tag2="string";tag3 key: <base-value>;tag1=token;tag2="string";tag3

The base-value will be placed in the dictionary where the key is the empty string. If the base-value is quoted with '<', '>' brackets then the brackets are removed. Note that the string "<>" can be used to have an empty base-value but a field starting with a ';' is illegal and this function will return false.

Each tag will be the key for it's entry in the dictionary, if that tag has no '=' sign then it will have an empty string as its value. If the tag value is quoted using '"', then the RFC822 rules are applied and the quotes and '\' charcters removed.

IF there are multiple "key" entries in the MIME, or there is an entry of the form:

key: <base-value>;tag=token, <base-value1>, <base-value2>;tag=token

then the first entry wil be as described above. All subsequent entries are includedin the dictionary with the key names having the string "n:" prepended, e.g. "1:" would be "base-value1", "2:tag" would be the tag value on the third entry.

Returns true if the field exists and base-value is non-empty or quoted.

Parameters

  key | Key into MIME dictionary to get info.
  info | Dictionary of information from field

References PStringOptions::GetString(), and ParseComplex().

bool PMIMEInfo::GetComplex | ( | const PString & | key,
|  | PStringToString & | info
| ) |  | const
| inline

Parameters

  key | Key into MIME dictionary to get info.
  info | Dictionary of information from field

References PStringOptions::GetString(), and ParseComplex().

bool PMIMEInfo::GetComplex | ( | const PCaselessString & | key,
|  | PStringToString & | info
| ) |  | const
| inline

Parameters

  key | Key into MIME dictionary to get info.
  info | Dictionary of information from field

References PStringOptions::GetString(), and ParseComplex().

bool PMIMEInfo::GetComplex | ( | const PCaselessString &(*)() | key,
|  | PStringToString & | info
| ) |  | const
| inline

Parameters

  key | Key into MIME dictionary to get info.
  info | Dictionary of information from field

References PStringOptions::GetString(), and ParseComplex().

static PString PMIMEInfo::GetContentType | ( | const PString & | fileType | ) |
| static

Look up the file type to MIME content type association dictionary and return the MIME content type string.

If the file type is not found in the dictionary then the string "application/octet-stream" is returned.

Returns
  MIME content type for file type.

Parameters

  fileType | File type (extension) to look up.

virtual bool PMIMEInfo::InternalAddMIME | ( | const PString & | fieldName,
|  | const PString & | fieldValue
| ) |  |
| virtual

Parameters

  fieldName | MIME field name
  fieldValue | MIME field value

Referenced by AddMIME().

static bool PMIMEInfo::ParseComplex | ( | const PString & | str,
|  | PStringToString & | info
| ) |  |
| static

Parse the string as a complex field, see GetComplex()

Parameters

  str | String value from MIME field.
  info | Dictionary of information from field

Referenced by GetComplex().

virtual ostream& PMIMEInfo::PrintContents | ( | ostream & | strm | ) | const
| virtual

Output the contents without the trailing CRLF.

virtual void PMIMEInfo::PrintOn | ( | ostream & | strm | ) | const
| virtual

Output the contents of the MIME dictionary to the stream.

This is primarily used by the standard `operator<<` function.

Parameters

  strm | Stream to print the object into.

Reimplemented from PAbstractDictionary.

PBoolean PMIMEInfo::Read | ( | PInternetProtocol & | socket | ) |

Read MIME information from the socket.

Returns
  true if the MIME information was successfully read.

Parameters

  socket | Application socket to read MIME info.

virtual void PMIMEInfo::ReadFrom | ( | istream & | strm | ) |
| virtual

Input the contents of the MIME dictionary from the stream.

This is primarily used by the standard `operator>>` function.

Parameters

  strm | Stream to read the objects contents from.

Reimplemented from PStringToString.

static void PMIMEInfo::SetAssociation | ( | const PStringToString & | allTypes,
|  | PBoolean | merge = `true`
| ) |  |
| static

Set an association between a file type and a MIME content type.

The content type is then sent for any file in the directory sub-tree that has the same extension.

Note that if the `merge` parameter if true then the dictionary is merged into the current association list and is not a simple replacement.

The default values placed in this dictionary are:

              ".txt", "text/plain"
              ".text", "text/plain"
              ".html", "text/html"
              ".htm", "text/html"
              ".aif", "audio/aiff"
              ".aiff", "audio/aiff"
              ".au", "audio/basic"
              ".snd", "audio/basic"
              ".wav", "audio/wav"
              ".gif", "image/gif"
              ".xbm", "image/x-bitmap"
              ".tif", "image/tiff"
              ".tiff", "image/tiff"
              ".jpg", "image/jpeg"
              ".jpe", "image/jpeg"
              ".jpeg", "image/jpeg"
              ".avi", "video/avi"
              ".mpg", "video/mpeg"
              ".mpeg", "video/mpeg"
              ".qt", "video/quicktime"
              ".mov", "video/quicktime"

       The default content type will be "application/octet-stream".

Parameters

  allTypes | MIME content type associations.
  merge | Flag for merging associations.

static void PMIMEInfo::SetAssociation | ( | const PString & | fileType,
|  | const PString & | contentType
| ) |  |
| inline static

Parameters

  fileType | File type (extension) to match.
  contentType | MIME content type string.

References PStringDictionary< K >::SetAt().

static const PCaselessString& PMIMEInfo::TextPlain | ( |  | ) |
| static

PBoolean PMIMEInfo::Write | ( | PInternetProtocol & | socket | ) | const

Write MIME information to the socket.

Returns
  true if the MIME information was successfully read.

Parameters

  socket | Application socket to write MIME info.

The documentation for this class was generated from the following file:

- mime.h